<form (ngSubmit)="onSubmit()"
      [formGroup]="form"
>

  <solidify-detail-presentation [centerTemplate]="centerTemplate"
                                [leftTemplate]="leftTemplate"
                                [rightTemplate]="rightTemplate"
                                class="shared-detail-presentation"
  ></solidify-detail-presentation>

  <ng-template #leftTemplate>
    <solidify-image-upload-wrapper-container [resourceFileNameSpace]="organizationalUnitActionNameSpace"
                                             [resourceFileState]="$any(organizationalUnitState)"
                                             [uploadInstantly]="false"
                                             [isEditable]="(model | isNullOrUndefined) || editAvailable"
                                             (logoChange)="logoChange($event)"
    ></solidify-image-upload-wrapper-container>
  </ng-template>

  <ng-template #centerTemplate>

    <mat-form-field *ngIf="getFormControl(formDefinition.name) as fd"
                    [appearance]="appearanceInputMaterial"
                    [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                    solidifyTooltipOnEllipsis
    >
      <mat-label>{{labelTranslateEnum.nameLabel | translate}}</mat-label>
      <input (blur)="checkAvailable(formDefinition.name, fd)"
             [solidifyDataTest]="dataTestEnum.adminOrgUnitName"
             [formControl]="fd"
             [required]="formValidationHelper.hasRequiredField(fd)"
             [solidifyValidation]="errors"
             matInput
      >
      <mat-error #errors
                 solidifyTooltipOnEllipsis
      ></mat-error>
    </mat-form-field>

    <solidify-multi-select (navigate)="navigateToSubmissionPolicy($event)"
                           *ngIf="getFormControl(formDefinition.submissionPolicies) as fd"
                           [solidifyDataTest]="dataTestEnum.adminOrgUnitSubmissionPolicy"
                           [formControlDefault]="getFormControl(formDefinition.defaultSubmissionPolicy)"
                           [formControl]="fd"
                           [isWithLink]="true"
                           [labelKey]="'name'"
                           [list]="listSubmissionPolicies"
                           [matTooltipPosition]="'left'"
                           [matTooltipShowDelay]="TIME_BEFORE_DISPLAY_TOOLTIP"
                           [matTooltip]="'orgUnit.tooltips.submissionPolicy' | translate"
                           [placeholder]="labelTranslateEnum.clickHereToAddAPolicy | translate"
                           [required]="formValidationHelper.hasRequiredField(fd)"
                           [title]="labelTranslateEnum.submissionPolicies | translate"
                           [tooltipNavigateToTranslate]="labelTranslateEnum.seeSubmissionPolicyDetail | translate"
                           [valueKey]="'resId'"
                           aria-label="submission policy input"
    >
    </solidify-multi-select>

    <solidify-multi-select (navigate)="navigateToPreservationPolicy($event)"
                           *ngIf="getFormControl(formDefinition.preservationPolicies) as fd"
                           [solidifyDataTest]="dataTestEnum.adminOrgUnitPreservationPolicy"
                           [formControlDefault]="getFormControl(formDefinition.defaultPreservationPolicy)"
                           [formControl]="fd"
                           [isWithLink]="true"
                           [labelKey]="'name'"
                           [list]="listPreservationPolicies"
                           [matTooltipPosition]="'left'"
                           [matTooltipShowDelay]="TIME_BEFORE_DISPLAY_TOOLTIP"
                           [matTooltip]="'orgUnit.tooltips.preservationPolicy' | translate"
                           [placeholder]="labelTranslateEnum.clickHereToAddAPolicy | translate"
                           [required]="formValidationHelper.hasRequiredField(fd)"
                           [title]="labelTranslateEnum.preservationPolicies | translate"
                           [tooltipNavigateToTranslate]="labelTranslateEnum.seePreservationPolicyDetail | translate"
                           [valueKey]="'resId'"
                           aria-label="preservation policy input"
    >
    </solidify-multi-select>

    <dlcm-shared-organizational-unit-dissemination-policy-parameters #organizationalUnitDisseminationPolicyParametersPresentational
                                                                     [selectedDisseminationPolicies]="selectedDisseminationPolicies"
                                                                     [formControl]="getFormControl(formDefinition.disseminationPolicies)"
                                                                     (navigate)="navigate($event)"
    ></dlcm-shared-organizational-unit-dissemination-policy-parameters>

    <mat-form-field *ngIf="getFormControl(formDefinition.description) as fd"
                    [appearance]="appearanceInputMaterial"
                    [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                    solidifyTooltipOnEllipsis
    >
      <mat-label>{{labelTranslateEnum.description | translate}}</mat-label>
      <textarea [formControl]="fd"
                [required]="formValidationHelper.hasRequiredField(fd)"
                [solidifyValidation]="errors"
                cdkAutosizeMaxRows="10"
                cdkAutosizeMinRows="3"
                cdkTextareaAutosize
                matInput
      >
        </textarea>
      <mat-error #errors
                 solidifyTooltipOnEllipsis
      ></mat-error>
    </mat-form-field>

    <solidify-searchable-multi-select (navigate)="navigateToFundingAgency($event)"
                                      *ngIf="getFormControl(formDefinition.fundingAgencies) as fd"
                                      [formControl]="fd"
                                      [isWithLink]="true"
                                      [labelKey]="'name'"
                                      [placeholder]="labelTranslateEnum.clickHereToAddAnAgency | translate"
                                      [required]="formValidationHelper.hasRequiredField(fd)"
                                      [resourceNameSpace]="sharedFundingAgencyActionNameSpace"
                                      [sort]="sharedFundingAgencySort"
                                      [state]="sharedFundingAgencyState"
                                      [title]="labelTranslateEnum.fundingAgencies | translate"
                                      [tooltipNavigateToTranslate]="labelTranslateEnum.seeFundingAgencyDetail | translate"
                                      [valueKey]="'resId'"
                                      [overlayComponent]="$any(fundingAgencyOverlayComponent)"
                                      aria-label="funding agencies"
                                      solidifyValidation
    >
    </solidify-searchable-multi-select>

    <solidify-searchable-multi-select (navigate)="navigateToInstitution($event)"
                                      *ngIf="getFormControl(formDefinition.institutions) as fd"
                                      [formControl]="fd"
                                      [isWithLink]="isAdminOrRoot"
                                      [labelKey]="'name'"
                                      [placeholder]="labelTranslateEnum.clickHereToAddAnInstitution | translate"
                                      [required]="formValidationHelper.hasRequiredField(fd)"
                                      [resourceNameSpace]="sharedInstitutionActionNameSpace"
                                      [sort]="sharedInstitutionSort"
                                      [state]="sharedInstitutionState"
                                      [title]="labelTranslateEnum.institutions | translate"
                                      [tooltipNavigateToTranslate]="labelTranslateEnum.seeInstitutionDetail | translate"
                                      [valueKey]="'resId'"
                                      [overlayComponent]="$any(institutionOverlayComponent)"
                                      aria-label="institution"
                                      solidifyValidation
    >
    </solidify-searchable-multi-select>

    <solidify-searchable-single-select #licenseSingleSearchableSelect
                                       *ngIf="getFormControl(formDefinition.defaultLicense) as fd"
                                       (navigate)="navigateToLicense($event)"
                                       [defaultValueTooltip]="'defaultValue' | translate"
                                       [defaultValue]="defaultPlatformLicenseId"
                                       [formControl]="fd"
                                       [isWithLink]="true"
                                       [labelCallback]="licenseCallback"
                                       [labelKey]="'title'"
                                       [placeholder]="labelTranslateEnum.license | translate"
                                       [required]="formValidationHelper.hasRequiredField(fd)"
                                       [resourceNameSpace]="sharedLicenseActionNameSpace"
                                       [sort]="sharedLicenseSort"
                                       [state]="sharedLicenseState"
                                       [tooltipNavigateToTranslate]="labelTranslateEnum.seeLicenseDetail | translate"
                                       [urlKey]="'url'"
                                       [valueKey]="'resId'"
                                       [overlayComponent]="$any(licenseOverlayComponent)"
                                       aria-label="license"
                                       solidifyValidation
    >
    </solidify-searchable-single-select>

  </ng-template>

  <ng-template #rightTemplate>

    <mat-form-field *ngIf="getFormControl(formDefinition.openingDate) as fd"
                    [appearance]="appearanceInputMaterial"
                    [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                    (click)="openingDateDatepicker.open()"
                    solidifyTooltipOnEllipsis
    >
      <mat-label>{{labelTranslateEnum.opening | translate}}</mat-label>
      <input [formControl]="fd"
             [matDatepicker]="openingDateDatepicker"
             matInput
      >
      <mat-datepicker-toggle [for]="openingDateDatepicker"
                             matSuffix
      ></mat-datepicker-toggle>
      <mat-datepicker #openingDateDatepicker
                      [touchUi]="breakpointService.isSmallerThanMd()"
      ></mat-datepicker>
    </mat-form-field>

    <mat-form-field *ngIf="getFormControl(formDefinition.closingDate) as fd"
                    [appearance]="appearanceInputMaterial"
                    [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                    (click)="closingDateDatepicker.open()"
                    solidifyTooltipOnEllipsis
    >
      <mat-label>{{labelTranslateEnum.closing | translate}}</mat-label>
      <input [formControl]="fd"
             [matDatepicker]="closingDateDatepicker"
             matInput
      >
      <mat-datepicker-toggle [for]="closingDateDatepicker"
                             matSuffix
      ></mat-datepicker-toggle>
      <mat-datepicker #closingDateDatepicker
                      [touchUi]="breakpointService.isSmallerThanMd()"
      ></mat-datepicker>
    </mat-form-field>

    <mat-form-field *ngIf="getFormControl(formDefinition.filterSubjectAreas) as fd"
                    [appearance]="appearanceInputMaterial"
                    [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                    [matTooltipPosition]="'left'"
                    [matTooltipShowDelay]="TIME_BEFORE_DISPLAY_TOOLTIP"
                    [matTooltip]="'admin.organizationalUnit.form.subjectAreaSource.tooltip' | translate"
                    solidifyTooltipOnEllipsis
    >
      <mat-label>{{labelTranslateEnum.filteringSubjectAreaBySource | translate}}</mat-label>
      <mat-select (valueChange)="filterSubjectArea($event)"
                  [formControl]="fd"
      >
        <mat-option [value]="''"
                    solidifyTooltipOnEllipsis
        >
          {{labelTranslateEnum.noFiltering | translate}}
        </mat-option>
        <mat-option *ngFor="let source of subjectAreaSources"
                    [value]="source"
                    solidifyTooltipOnEllipsis
        >
          {{source}}
        </mat-option>
      </mat-select>
    </mat-form-field>

    <solidify-searchable-multi-select *ngIf="getFormControl(formDefinition.subjectAreas) as fd"
                                      [extraInfoLabelKey]="'code'"
                                      [extraSearchQueryParam]="subjectAreaExtraSearchParameterSource"
                                      [formControl]="fd"
                                      [isWithLink]="true"
                                      [labelCallback]="subjectAreaLabelCallback"
                                      [labelKey]="'name'"
                                      [placeholder]="labelTranslateEnum.clickHereToAddASubjectArea | translate"
                                      [required]="formValidationHelper.hasRequiredField(fd)"
                                      [resourceNameSpace]="sharedSubjectAreaActionNameSpace"
                                      [searchKey]="'nameOrCode'"
                                      [sort]="sharedSubjectAreaSort"
                                      [state]="sharedSubjectAreaState"
                                      [title]="labelTranslateEnum.subjectAreas | translate"
                                      [tooltipNavigateToTranslate]="labelTranslateEnum.seeSubjectAreaDetail | translate"
                                      [valueKey]="'resId'"
                                      (navigate)="navigateToSubjectArea()"
                                      aria-label="subject area"
                                      solidifyValidation
    >
    </solidify-searchable-multi-select>

    <solidify-keyword-input *ngIf="getFormControl(formDefinition.keywords) as fd"
                            [formControl]="fd"
                            [spaceDelimiter]="false"
    >
    </solidify-keyword-input>

    <solidify-url-input-navigator *ngIf="getFormControl(formDefinition.url) as fd"
                                  [formControl]="fd"
    >
    </solidify-url-input-navigator>

    <button (click)="navigateToDeposit(model.resId)"
            (onEnter)="navigateToDeposit(model.resId)"
            *ngIf="model?.resId && readonly"
            [solidifyAlternativeButtonIcon]="true"
            solidifyAlternativeButton
            solidifyShortCuts
    >
      <solidify-icon [iconName]="iconNameEnum.deposit"
                     class="icon size-18"
      ></solidify-icon>
      <span class="text">{{labelTranslateEnum.seeDeposits | translate}}</span>
    </button>

    <button (click)="navigateToArchive()"
            (onEnter)="navigateToArchive()"
            *ngIf="model?.resId && readonly"
            [solidifyAlternativeButtonIcon]="true"
            solidifyAlternativeButton
            solidifyShortCuts
    >
      <solidify-icon [iconName]="iconNameEnum.archive"
                     class="icon size-18"
      ></solidify-icon>
      <span class="text">{{labelTranslateEnum.seeArchives | translate}}</span>
    </button>

  </ng-template>

  <solidify-panel-expandable [isOpen]="true"
                             [titleToTranslate]="labelTranslateEnum.organizationalUnitMembers | translate"
                             [icon]="iconNameEnum.organizationalUnit"
                             class="section"
  >
    <dlcm-shared-table-person-role-container [formControl]="getFormControl(formDefinition.personRole)"
                                             [listRole]="listRole"
                                             [readonly]="readonly"
                                             [selectedResourceRole]="selectedPersonRole"
                                             (navigate)="navigate($event)"
    ></dlcm-shared-table-person-role-container>
  </solidify-panel-expandable>

  <solidify-panel-expandable *ngIf="readonly && (inheritedSelectedPersonRole | isNonEmptyArray)"
                             [isOpen]="true"
                             [titleToTranslate]="(getFormControl(formDefinition.institutions)?.value?.length > 1 ? labelTranslateEnum.institutionsMembers :
                               labelTranslateEnum.institutionMembers) | translate"
                             [icon]="iconNameEnum.institutions"
                             class="section"
  >
    <dlcm-shared-table-person-role-container *ngIf="getFormControl(formDefinition.inheritedPersonRole) as fd"
                                             [formControl]="fd"
                                             [listRole]="listRole"
                                             [readonly]="true"
                                             [preventEdition]="true"
                                             [selectedResourceRole]="inheritedSelectedPersonRole"
                                             [isWithLinkToAdmin]="true"
                                             (navigate)="navigate($event)"
                                             [class]="classBypassEdit"
    ></dlcm-shared-table-person-role-container>
  </solidify-panel-expandable>

  <dlcm-shared-additional-information-panel-container *ngIf="model | isNotNullNorUndefined"
                                                      [resource]="model"
  >
  </dlcm-shared-additional-information-panel-container>
</form>
